IMPLEMENTATION MODULE E2Paster;

FROM E2Functions IMPORT LineNumber, Length;
FROM E2Variables IMPORT lineptr, paste1, paste;
FROM E2Pointer   IMPORT SetPtr, CopyPointer, JoinPtr;

PROCEDURE Append(VAR p : lineptr);

BEGIN   Cut(p);
        JoinPtr(paste4,paste1);
        paste1 := paste3;
END Append;     

PROCEDURE Replace(VAR p : lineptr);

BEGIN   Cut(p);
        paste1 := paste3;       
        paste2 := paste4;       
        Paste(p); 
END Replace; 

PROCEDURE Paste(VAR p : lineptr);

VAR     p1, p2, p3, p4, top : lineptr;

BEGIN   IF paste THEN p1 := paste3; p2 := paste4
        ELSE p1 := paste1; p2 := paste2; END;
        SetPtr(p4,Length(p1^.line));
        top := p4;p3 := p4;
        CopyPointer(p4,p1);
        WHILE (p1 # p2) AND (p1^.down # NIL) DO
          p1 := p1^.down;
          SetPtr(p4,Length(p1^.line));
          CopyPointer(p4,p1);
          JoinPtr(p3,p4);
          p3 := p3^.down;
          END;
        IF p^.up # NIL THEN 
              JoinPtr(p^.up,top);
        ELSE  
              top^.up := NIL;
        END;
        JoinPtr(p4,p);
END Paste;

PROCEDURE Reset(VAR p : lineptr);

BEGIN   paste1 := paste3;
        paste2 := paste4;
        paste := FALSE;
END Reset;

PROCEDURE Select(p : lineptr);

BEGIN  IF NOT paste THEN 
         paste := TRUE;
         paste3 := paste1;
         paste4 := paste2;
         paste1 := p;
       END
END Select;

PROCEDURE CutPart(VAR p : lineptr);

VAR     p1 : lineptr;

BEGIN   paste := FALSE;
        paste2 := p;
        IF paste2^.down = NIL THEN  paste2 := paste2^.up END;
        IF LineNumber(p) < LineNumber(paste1) THEN  
               p1 := paste1;  
               paste1 := paste2;
               paste2 := p1;
               END;
END CutPart;

PROCEDURE Cut(VAR p : lineptr);

BEGIN   CutPart(p);
        IF paste2^.down = NIL THEN paste2 := paste2^.up END;
        p := paste2^.down;
        IF paste1^.up = NIL THEN   
              paste2^.down^.up := NIL;
        ELSE  JoinPtr(paste1^.up,paste2^.down);
        END
END Cut;

END E2Paster.
