IMPLEMENTATION MODULE Random;  (* Random number generator *)

FROM SYSTEM IMPORT ADDRESS;
FROM R2NewCalls IMPORT UpTime;

CONST   c16 = 65536;             
        r16 = 65536.0;  
        magic = 16807;

VAR     seed : ADDRESS;   
        den : REAL;

PROCEDURE  Float ( a : ADDRESS) : REAL;

VAR     f0, f1 : CARDINAL;

BEGIN   f0 := CARDINAL(a DIV c16);
        f1 := CARDINAL(a MOD c16);
        RETURN FLOAT(f0)*r16 + FLOAT(f1);
END Float;

PROCEDURE  Rand() : REAL;

VAR     x : REAL;

BEGIN   seed := ADDRESS(magic) * seed;
        RETURN Float(seed) * den;
END Rand;     

PROCEDURE  ReRandomise;

BEGIN   UpTime(seed);
END ReRandomise;

BEGIN   den := 1.0 / (Float(c16)*Float(c16));
        seed := 12345;
END Random.
