MODULE ArpCache;
FROM R2NewerCalls IMPORT StatsCache;
FROM R2SysCalls IMPORT WriteString,WriteLn;
FROM R2NumbIO IMPORT WriteCard;
VAR
  Ipnumber:ARRAY[0..3] OF CHAR;
  Hnumber:ARRAY[0..5] OF CHAR;
  valid:BOOLEAN;
  resolved:BOOLEAN;
  num,i:CARDINAL;
BEGIN
   num:=0;                        
   WriteString('**Arp Cache Statistics**');WriteLn;
   WriteString('    Ipnumber');WriteString('       ');
   WriteString('Physical address');
   WriteString('     ');WriteString('  Resolved');WriteLn;

(*This loop is used to obtain all the information in the arp cache
  one node at a time*)

   LOOP
     valid:=StatsCache(Ipnumber,Hnumber,resolved,num);
     IF NOT valid THEN
       EXIT;
     ELSE                          
       FOR i:=0 TO 3 DO
         WriteCard(ORD(Ipnumber[i]),4);
       END;
       FOR i:=0 TO 5 DO
         WriteCard(ORD(Hnumber[i]),4);
       END;
       IF resolved THEN
         WriteString('    TRUE');
       ELSE
         WriteString('    FALSE');
       END(*IF*);       
       INC(num);                                   
       WriteLn;
     END(*IF*);
   END(*LOOP*);
END ArpCache.
