MODULE CheckConfig;
FROM R2NewerCalls IMPORT NetConfig, DNSInfo;
FROM R2SysCalls   IMPORT WriteString, WriteLn, Write;
FROM SYSTEM       IMPORT ADDRESS;
FROM R2NumbIO     IMPORT WriteCard;
FROM R2NetSubs    IMPORT WriteIPAddr;
VAR
  dname,server1,server2: ARRAY[0..50] OF CHAR;
  Saddr1,Saddr2,ipnum,mask:ADDRESS;
  hostIP,gateIP:ARRAY[0..3] OF CHAR;
  b:BOOLEAN;                                                          

(*This procedure displays the four octets representing an IP number
  in the proper format*)

PROCEDURE Display(ip:ARRAY OF CHAR);
VAR 
  j:CARDINAL;
BEGIN
  FOR j:=0 TO 3 DO      
     WriteCard(ORD(ip[j]),0);
     IF j<3 THEN
       Write('.');
     END(*IF*);
  END(*FOR*);
  WriteLn;
END Display;

BEGIN               
  DNSInfo(hostIP,gateIP,dname,server1,server2,Saddr1,Saddr2,mask);
  WriteString('Our HostIP num-->');       (*displays network configuration*)
  Display(hostIP);                               (*information*)
  WriteString('GateIP num-->');
  Display(gateIP);                  
  WriteString('Our Domain Name-->');
  WriteString(dname);WriteLn;      
  WriteString('DNS server1-->');
  WriteString(server1);WriteLn;  
  WriteString('DNS server2-->');
  WriteString(server2);WriteLn;  
  WriteString('IP address of DNS server1-->');
  WriteIPAddr(Saddr1,12);WriteLn;             
  WriteString('IP address of DNS server2-->');
  WriteIPAddr(Saddr2,12);WriteLn;             
  WriteString('NetMask-->');
  WriteIPAddr(mask,12);WriteLn;   
END CheckConfig.                                                     
