MODULE DayReply;        
FROM SYSTEM       IMPORT ADDRESS;
FROM R2NetSubs    IMPORT ScanIPAddr;
FROM R2SysCalls   IMPORT GetPID, GetTime, Status, Time, Sleep, SetCCMode;
FROM R2TimeSubs   IMPORT FormatTime; 
FROM R2NewerCalls IMPORT SetUDPPort, Send, ProcessStats, Port, IPAddr,
                          Receive;
                  IMPORT R2NewerCalls;
FROM R2Strings    IMPORT Length, Insert, Copy;

VAR
  rt:R2NewerCalls.Status;

PROCEDURE DayWatch();                                            
VAR
  start:R2NewerCalls.Time;
  t:Time;
  len:CARDINAL;                                                      
  rs:Status;     
  forPort,port:Port;
  tmos,sent,rcvd:ADDRESS;
  str,data:ARRAY[0..100] OF CHAR; 
  forHost:IPAddr;                    
  s:ARRAY[0..4] OF CHAR;
BEGIN
  s[0]:=15C;                                      (*Carriage return*)
  s[1]:=12C;                                      (*Line feed*)
  s[2]:=0C;                                       (*Terminate string*)
  LOOP                                            (*Wait for requests, by*)
    rt:=Receive(data,len,tmos,forPort,forHost);   (*just looping*)
    IF rt=R2NewerCalls.Ok THEN        
      rs:=GetTime(t);
      IF rs=Ok THEN
        FormatTime(t,str);                        (*Format time and send*)
        len:=Length(str);                         (*it in the packet*)
        Insert(s,str,len);INC(len,2);
        rs:=Sleep(3);
        rt:=Send(str,len,forPort,forHost);
      ELSE
        Copy('Could not get time',str);           (*If could not obtain*)
        len:=Length(str);                         (*time then send a message*)
        Insert(s,str,len);INC(len,2);
        rs:=Sleep(3);
        rt:=Send(str,len,forPort,forHost);
      END(*IF*);
    END(*IF*);
  END(*LOOP*);
END DayWatch;

BEGIN
  SetCCMode(FALSE);
  rt:=SetUDPPort(13);                               (*obtain port 13*)

(*If can not get port 13 then die*)

  IF rt=R2NewerCalls.Ok THEN
    DayWatch();
  END(*IF*);
END DayReply.      
