MODULE Echo;
FROM TelOpts IMPORT IAC, DONT, DOIT, WONT, WILL, RDont, RDo, RWill, RWont,
                    SDo, SDont, SWill, SWont, Echo, SuppressGA, RegisterSoc,
                    TInit;
FROM R2NewCalls IMPORT AttachTerminal;
FROM R2SysCalls IMPORT WriteString, WriteLn, Sleep, Result, Write, SetCCMode;
FROM R2NewerCalls IMPORT TCPListen, TCPWrite, TCPRead, TCPClose, TCPAttach,
                         GetMessage, TCPDetach, Port, SocHandle, Status,
                         IPAddr, VTIn, VTOut, VTAllocate, VTDeallocate,
                         SetPriority;
IMPORT R2SysCalls;
FROM R2NumbIO IMPORT WriteCard; 

CONST
  TelnetPort = 23;
  tmo     = 1000;
  CR      = 15C;
  LF      = 12C;

VAR
  pos,len,unit:CARDINAL;
  s:ARRAY[0..2048] OF CHAR;
  Fiac,Fcmnd,OptMode:BOOLEAN;
  forHost : IPAddr;
  port : Port;                      
  soc  : SocHandle;
  t1 : ARRAY [0..30] OF CHAR;                                        
  ch : CHAR;


                 
VAR             
  fin : BOOLEAN;              
  l2res:R2SysCalls.Status;
  n2res:Status;
  done, i:CARDINAL;
  t:ARRAY[0..2047] OF CHAR;
BEGIN (*MAIN*)
  SetCCMode( FALSE );
  l2res := SetPriority(4);
    LOOP
      TInit;
      SWill(Echo);
      SDo(SuppressGA);
      n2res:=TCPListen(TelnetPort,soc);
IF n2res=Ok THEN WriteString('ok');END;
      n2res := TCPAttach(soc);
      LOOP                    
        l2res:=Sleep(tmo); 
        IF l2res=R2SysCalls.Ok THEN
           n2res:=TCPRead(soc,s,len,FALSE);
           n2res:=TCPWrite(soc,s,len);
        END(*IF*);
      END(*LOOP*);
      n2res:=TCPClose(soc);
    END(*LOOP*);
WriteString('ended');
END Echo.
