MODULE EchoServer;

FROM R2NewerCalls IMPORT TCPListen, TCPWrite, TCPRead, TCPClose, Status,
                         SocHandle;
FROM R2SysCalls   IMPORT Process, Sleep, GetPID, SetUser;
                  IMPORT R2SysCalls;

CONST
  EchoPort =7 ;

VAR                                
  l2res : R2SysCalls.Status;
  n2res : Status;
  soc   : SocHandle;
  len   : CARDINAL;                                     
  data  : ARRAY[0..2047] OF CHAR;
  pid   : Process;

BEGIN             
  l2res := GetPID( pid );
  l2res := SetUser( pid, 0 );
  LOOP
    n2res:=TCPListen(EchoPort,soc);
    IF n2res<>Ok THEN 
      l2res := Sleep(1000);
    ELSE                  
      LOOP
        n2res := TCPRead( soc, data, len, TRUE );
        n2res := TCPWrite( soc, data ,len );
        IF n2res<>Ok THEN
          EXIT;
        END; (* IF *)
      END; (* LOOP *)
      n2res := TCPClose(soc);
    END; (* IF *)
  END(*LOOP*);
END EchoServer.
