IMPLEMENTATION MODULE R2NewerCalls;

FROM SYSTEM IMPORT ADDRESS, CODE, SETREG;
IMPORT R2SysCalls;

CONST    Trap15 = 047117B;
         PopA0  = 020137B;
         JmpA0  = 047320B;
         MoveQ1 = 071000B;

(*$T-*)
(*$P-*)
PROCEDURE Qquery(VAR Qsize, maxsize: CARDINAL);
BEGIN   CODE(MoveQ1+73);
        CODE(PopA0,Trap15,JmpA0);
END Qquery;         
             
(*$P-*)
PROCEDURE ArpStats(VAR ArpResp,ArpReq,cachenum,Pdisc,TArpPack:CARDINAL;
                          VAR Psent : ADDRESS);
BEGIN   CODE(MoveQ1+74);
        CODE(PopA0,Trap15,JmpA0);
END ArpStats;
      
(*$P-*)
PROCEDURE IPStats(VAR BadPktsChksum,PktsNotReg, WrongType, WrongDest,
                      BadVersionNum: CARDINAL; VAR PktsSentToLoc,
                                    PktsSentToGate, PktsRcvd : ADDRESS);
BEGIN   CODE(MoveQ1+75);
        CODE(PopA0,Trap15,JmpA0);
END IPStats;
      
(*$P-*)
PROCEDURE GlobalStats(VAR maxPorts,openPorts,
                          badPktsNoPort, badPktsChksum : CARDINAL;
                          VAR pktsQd,pktsSent,pktsRcvd:ADDRESS);
BEGIN   CODE(MoveQ1+76);
        CODE(PopA0,Trap15,JmpA0);
END GlobalStats;
      
(*$P-*)
PROCEDURE ICMPStats(VAR echo, other, bad : CARDINAL );
BEGIN   CODE(MoveQ1+77);
        CODE(PopA0,Trap15,JmpA0);
END ICMPStats;

(*$P-*)                                           
PROCEDURE SetPriority( priority : CARDINAL ) : R2SysCalls.Status;
BEGIN  CODE(MoveQ1+78);
       CODE(PopA0,Trap15,JmpA0);
END SetPriority;

(*$P-*)
PROCEDURE StatsCache(VAR Ipnum,Hnum:ARRAY OF CHAR;VAR resolved:BOOLEAN;
                         num:CARDINAL):BOOLEAN;
BEGIN   CODE(MoveQ1+79);
        CODE(PopA0,Trap15,JmpA0);
END StatsCache;

(*$P-*)
PROCEDURE SetUDPPort( port : Port ) :Status;
BEGIN   CODE(MoveQ1+80);
        CODE(PopA0,Trap15,JmpA0);
END SetUDPPort;

(*$P-*)
PROCEDURE Send(VAR data : ARRAY OF CHAR; len : CARDINAL;
               forPort : Port; forHost : IPAddr ) : Status;
BEGIN   CODE(MoveQ1+81);
        CODE(PopA0,Trap15,JmpA0);
END Send;

(*$P-*)
PROCEDURE Receive(VAR data : ARRAY OF CHAR; VAR len : CARDINAL; tmo :Ticks;
                  VAR forPort : Port; VAR forHost : IPAddr ) : Status;
BEGIN   CODE(MoveQ1+82);
        CODE(PopA0,Trap15,JmpA0);
END Receive;

(*$P-*)
PROCEDURE ProcessStats(pid : Process; VAR port : Port;
                       VAR tmos, sent, rcvd : ADDRESS;
                       VAR start : Time ) : Status;
BEGIN   CODE(MoveQ1+83);
        CODE(PopA0,Trap15,JmpA0);
END ProcessStats;

(*$P-*)
PROCEDURE Ping( forHost : IPAddr; tmo : Ticks; size : CARDINAL;
                                 VAR rtt : Ticks ) : Status;
BEGIN   CODE(MoveQ1+84);
        CODE(PopA0,Trap15,JmpA0);
END Ping;  

(*$P-*)
PROCEDURE HeapSz( VAR size, frags : ADDRESS );
BEGIN   CODE(MoveQ1+85);
        CODE(PopA0,Trap15,JmpA0);
END HeapSz;

(*$P-*)
PROCEDURE SetDbg( dbgon : BOOLEAN );
BEGIN   CODE(MoveQ1+86);
        CODE(PopA0,Trap15,JmpA0);  
END SetDbg;

(*$P-*)
PROCEDURE TCPStats( VAR InSegs, PassOpen, Outs, EstResets, CurrEst, AttFails,
                    RetranSegs, OutSegs : ADDRESS );
BEGIN  CODE(MoveQ1+87);
       CODE(PopA0,Trap15,JmpA0);
END TCPStats;

(*$P-*)
PROCEDURE TCPListen( port : Port; VAR soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+88);
       CODE(PopA0,Trap15,JmpA0);
END TCPListen;

(*$P-*)            
PROCEDURE TCPOpen( forPort : Port; forHost : IPAddr;
                   VAR soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+89);
       CODE(PopA0,Trap15,JmpA0);
END TCPOpen;

(*$P-*)
PROCEDURE TCPWrite( soc : SocHandle; VAR data : ARRAY OF CHAR;
                    len : CARDINAL ):Status;
BEGIN  CODE(MoveQ1+90);
       CODE(PopA0,Trap15,JmpA0);
END TCPWrite;

(*$P-*)
PROCEDURE TCPRead( soc : SocHandle; VAR data : ARRAY OF CHAR;
                   VAR len : CARDINAL; wait : BOOLEAN ):Status;
BEGIN  CODE(MoveQ1+91);
       CODE(PopA0,Trap15,JmpA0);
END TCPRead;

(*$P-*)
PROCEDURE TCPClose( soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+92);
       CODE(PopA0,Trap15,JmpA0);
END TCPClose;
           
(*$P-*)
PROCEDURE TCPAbort( soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+93);
       CODE(PopA0,Trap15,JmpA0);
END TCPAbort;
           
(*$P-*)
PROCEDURE TCPAttach( soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+94);
       CODE(PopA0,Trap15,JmpA0);
END TCPAttach;
            

(*$P-*)
PROCEDURE TCPDetach( soc : SocHandle ):Status;
BEGIN  CODE(MoveQ1+95);
       CODE(PopA0,Trap15,JmpA0);
END TCPDetach;
            
(*$P-*)
PROCEDURE TCBInfo( soc : SocHandle; 
                   VAR tcb, sbuff, rbuff : ARRAY OF CHAR ):Status;
BEGIN  CODE(MoveQ1+96);
       CODE(PopA0,Trap15,JmpA0);
END TCBInfo;

(*$P-*)
PROCEDURE GetMessage( r : Status; VAR s : ARRAY OF CHAR);
BEGIN  CODE(MoveQ1+97);
       CODE(PopA0,Trap15,JmpA0);
END GetMessage;

(*$P-*)                                           
PROCEDURE NetConfig( HostIPNum, GateIPNum, OurDomainName, DNSServ1,
                     DNSServ2 : ARRAY OF CHAR; 
                     DNSServIP1, DNSServIP2 , Netmask: ADDRESS) : Status; 
BEGIN  CODE(MoveQ1+98);
       CODE(PopA0,Trap15,JmpA0);
END NetConfig;

(*$P-*)                                           
PROCEDURE DNSInfo( VAR HostIp, GateIp,OurDomainName,DNSServ1,
                       DNSServ2 : ARRAY OF CHAR;VAR DNSServIP1,
                       DNSServIP2, Netmask:ADDRESS);
BEGIN  CODE(MoveQ1+99);
       CODE(PopA0,Trap15,JmpA0);
END DNSInfo;

(*$P-*)
PROCEDURE VTIn( unit : CARDINAL; ch : CHAR) : R2SysCalls.Status;
BEGIN  CODE(MoveQ1+100);
       CODE(PopA0,Trap15,JmpA0);
END VTIn; 

(*$P-*)
PROCEDURE VTOut( unit : CARDINAL; VAR ch : CHAR ) : R2SysCalls.Status;
BEGIN  CODE(MoveQ1+101);
       CODE(PopA0,Trap15,JmpA0);
END VTOut;

(*$P-*)
PROCEDURE VTAllocate( VAR unit : CARDINAL) : R2SysCalls.Status;
BEGIN  CODE(MoveQ1+102);
       CODE(PopA0,Trap15,JmpA0);
END VTAllocate;

(*$P-*)                                           
PROCEDURE VTDeallocate( unit : CARDINAL );
BEGIN  CODE(MoveQ1+103);
       CODE(PopA0,Trap15,JmpA0);
END VTDeallocate;

(*$P-*)                                           
PROCEDURE HangUp( unit : CARDINAL ) : R2SysCalls.Status;
BEGIN  CODE(MoveQ1+104);
       CODE(PopA0,Trap15,JmpA0);
END HangUp;

END R2NewerCalls.
