IMPLEMENTATION MODULE Factor;

FROM R2Strings IMPORT Copy, Length;

CONST   max = 133;
        eos = max+1;

VAR     pattern, result : ARRAY [0..max] OF CHAR;
        st0, st1, next, alt : ARRAY [0..max] OF CARDINAL;
        sp : CARDINAL;

PROCEDURE  SetFactor( VAR s : ARRAY OF CHAR) : BOOLEAN;

VAR     nx, al, i, lp : CARDINAL;

BEGIN   lp := Length(s);
        sp := 0;
        IF lp > max THEN RETURN FALSE END;
        IF lp = 0 THEN RETURN TRUE END;
        Copy(s,pattern);
        nx := lp; al := eos;
        next[lp] := eos; alt[lp] := eos;
        st0[0] := nx; st1[0] := eos;
        FOR i := lp-1 TO 0 BY -1 DO
          next[i] := nx;
          CASE pattern[i] OF
              ")" : INC(sp); st0[sp] := i; st1[sp] := al;
                    nx := i;  alt[i] := eos; al := eos;
            | "," : alt[i] := al; al := i; nx := st0[sp];
            | "(" : alt[i] := al; nx := i; al := st1[sp];
                    IF sp > 0 THEN DEC(sp) ELSE RETURN FALSE END;
            ELSE    nx := i; alt[i] := eos;
            END;
          END;
        IF sp <> 0 THEN sp := 0; RETURN FALSE; END;
        IF al <> eos THEN INC(sp); st0[sp] := al; st1[sp] := 0; END;
        INC(sp); st0[sp] := nx; st1[sp] := 0;
        RETURN TRUE;
END SetFactor;

PROCEDURE  GetTerm( VAR s : ARRAY OF CHAR) : BOOLEAN;

VAR     ch : CHAR;
        pc, rc : CARDINAL;

BEGIN   IF sp = 0 THEN RETURN FALSE END;
        pc := st0[sp];
        rc := st1[sp];
        DEC(sp);
        REPEAT ch := pattern[pc];
               IF alt[pc] <> eos THEN
                 INC(sp);
                 st0[sp] := alt[pc];
                 st1[sp] := rc;
                 END;
               IF (ch <> '(') AND (ch <> ',') AND (ch <> ')') THEN
                 result[rc] := ch;
                 INC(rc);
                 END;
               pc := next[pc];
        UNTIL pc = eos;
        Copy(result,s);
        RETURN TRUE;
END GetTerm;

BEGIN   sp := 0;
END Factor.
