IMPLEMENTATION MODULE R2NumbIO;

FROM SYSTEM IMPORT ADDRESS;
FROM R2SysCalls IMPORT Time, WriteString, ReadString, WriteLn;
FROM R2Format IMPORT ScanCard, ScanAddr, FormatCard, FormatAddr, FormatTime;

VAR     str : ARRAY [0..79] OF CHAR;

PROCEDURE  WriteCard( c, w : CARDINAL);      (* in Decimal *)

BEGIN   FormatCard(c,10,w,str);
        WriteString(str);
END WriteCard;

PROCEDURE  WriteAddr( a : ADDRESS; r, w : CARDINAL);

BEGIN   FormatAddr(a,r,w,str);
        WriteString(str);
END WriteAddr;

PROCEDURE  ReadAddr( VAR a : ADDRESS; r : CARDINAL);

BEGIN   LOOP ReadString(str);
             IF NOT ScanAddr(str,r,a) 
               THEN WriteString('Try again: ');
               ELSE EXIT END;
             END;
END ReadAddr;

PROCEDURE  ReadCard( VAR c : CARDINAL);

BEGIN   LOOP ReadString(str);
             IF NOT ScanCard(str,10,c) 
               THEN WriteString('Try again: ');
               ELSE EXIT END;
             END;
END ReadCard;

PROCEDURE  WriteTime( t : Time);

BEGIN   FormatTime(t,str);
        WriteString(str);
END WriteTime;

END R2NumbIO.
