IMPLEMENTATION MODULE L2Storage[4];

FROM SYSTEM IMPORT ADDRESS;

TYPE    nodeptr = POINTER TO node;
        node =  RECORD  next : nodeptr;
                        size : ADDRESS;
                END;

VAR     empty : nodeptr;

PROCEDURE HeapSz( VAR size, frags : ADDRESS );

VAR     p : nodeptr;

BEGIN   p := empty;
        size := 0;
        frags := 0;
        WHILE p <> NIL DO
          size := size + p^.size;
          INC( frags );  
          p := p^.next;
          END;
END HeapSz;

PROCEDURE ALLOCATE (VAR addr : ADDRESS; s : CARDINAL);

VAR     p, q : nodeptr;

BEGIN   s := ((s + 7) DIV 8)*8;
        p := empty;
        q := NIL;
        addr := NIL;
        WHILE p <> NIL DO
          WITH p^ DO
            IF size >= ADDRESS(s) THEN 
              size := size - ADDRESS(s);
              addr := ADDRESS(p) + size;
              IF size = 0 THEN
                IF q = NIL 
                  THEN empty := next
                  ELSE q^.next := next 
                  END;
                END;
              p := NIL;
              ELSE q := p;
                   p := next;
              END;
            END;
          END;
END ALLOCATE;

PROCEDURE DEALLOCATE ( VAR addr : ADDRESS ; s : CARDINAL);

VAR     n, p, q : nodeptr;

BEGIN   n := nodeptr(addr);
        s := ((s + 7) DIV 8)*8;
        p := empty;
        q := NIL;
        n^.size := ADDRESS(s);
        n^.next := NIL;
        IF empty = NIL 
          THEN empty := n 
          ELSE WHILE (addr > ADDRESS(p)) AND (p <> NIL) DO
                 q := p;
                 p := p^.next;
                 END;
               IF q = NIL 
                 THEN empty := n 
                 ELSE q^.next := n;
                 END;
               n^.next := p;
               IF addr + ADDRESS(s) = ADDRESS(p) THEN 
                 n^.size := n^.size + p^.size;
                 n^.next := p^.next;
                 END;
               IF q <> NIL THEN 
                 IF ADDRESS(q) + q^.size = addr THEN
                   q^.size := q^.size + n^.size;
                   q^.next := n^.next;
                   END;
                 END;
               END;
        addr := NIL;
END DEALLOCATE;

BEGIN   empty := NIL;   (* Heap is initially empty - must be expanded by
                           calling DEALLOCATE *)
END L2Storage.
