IMPLEMENTATION MODULE L2TTNumber;

FROM SYSTEM IMPORT ADDRESS;
FROM L2TTIO IMPORT WriteString, ReadString, Write;

(*  Routines to do formatted numerical i/o  via the console *)

PROCEDURE  WriteCard( c, w : CARDINAL);      (* in Decimal *)

BEGIN   WriteAddr(ADDRESS(c),10,w);
END WriteCard;

PROCEDURE  WriteAddr( a : ADDRESS; r, w : CARDINAL);

(* Handles up to base 36 *)

VAR     s : ARRAY [1..100] OF CHAR;
        i, c : CARDINAL;

BEGIN   i := 1;
        WHILE (( a > 0 ) OR (w > 0)) AND (i < 100)  DO
          c := CARDINAL(a MOD ADDRESS(r));
          IF c < 10 THEN c := c + 48 ELSE c := c + 55 END;
          s[i] := CHR(c);
          IF (a = 0) AND (i > 1) THEN s[i] := ' ' END;
          a := a DIV ADDRESS(r);
          INC(i); 
          IF w > 0 THEN DEC(w) END;
          END;
        REPEAT DEC(i);
               Write(s[i]);
        UNTIL i = 1;
END WriteAddr;

PROCEDURE  ReadAddr( VAR a : ADDRESS; r : CARDINAL);

(* Handles up to base 36 *)

VAR     s : ARRAY [1..100] OF CHAR;
        i, d : CARDINAL;

BEGIN   i := 1;
        a := 0;
        ReadString(s);
        LOOP    IF i > 100 THEN EXIT END;
                IF s[i] < '0' THEN EXIT END;
                IF (s[i] > '9') AND (s[i] < 'A') THEN EXIT END;
                IF s[i] > 'Z' THEN EXIT END;
                d := ORD(s[i]) - 48;
                IF d > 9 THEN d := d - 7 END;
                IF d >= r THEN EXIT END;
                a := ADDRESS(r)*a + ADDRESS(d);
                INC(i);
                END;
END ReadAddr;

PROCEDURE  ReadCard( VAR c : CARDINAL);

VAR     a : ADDRESS;

BEGIN   ReadAddr(a,10);
        c := CARDINAL(a);
END ReadCard;

END L2TTNumber.
