MODULE Message;  (* Send a 'beep message' to a user *)

FROM R2SysCalls IMPORT GetCommand, Status, GetPID, WriteString, WriteLn;
FROM R2NewCalls IMPORT WriteMessage, GetName;
FROM R2Strings IMPORT Remove, Substring, Insert;

PROCEDURE  Component( VAR s, t : ARRAY OF CHAR);

VAR     a : CARDINAL;

BEGIN   a := 0;
        WHILE (a <= HIGH(s)) AND (s[a] = " ") DO INC(a) END;
        Remove(s,0,a);
        a := 0;
        WHILE (a <= HIGH(s)) AND (s[a] > " ") DO INC(a) END;
        Substring(s,t,0,a);
        IF t[0] = ";" THEN t[0] := 0C; RETURN END;  (* Comments *)
        Remove(s,0,a);
END Component;

VAR     rs : Status;
        me, yu, ms, tm : ARRAY [0..79] OF CHAR;
        pid : CARDINAL;

BEGIN   rs := GetPID(pid);
        rs := GetName(pid,me);
        GetCommand(ms);
        Component(ms,yu);
        tm[0] := 15C; tm[1] := 12C; tm[2] := 7C; tm[3] := '(';
        tm[4] := ')'; tm[5] := ' '; tm[6] := 15C; tm[7] := 12C;
        tm[8] := 0C;
        Insert(ms,tm,6);
        Insert(me,tm,4);
        rs := WriteMessage(yu,tm);
        IF rs = NoSuch 
            THEN WriteString("Message -- User not logged in"); 
                 WriteLn;
          ELSIF rs <> Ok
            THEN WriteString("Message -- Unable to write to user's terminal");
                 WriteLn;
          END;
END Message.
