MODULE ShowCache;  (* display info about directory cache *)
                      
FROM SYSTEM IMPORT ADDRESS;
FROM R2SysCalls IMPORT WriteLn, Status, WriteString;
FROM MoreCalls IMPORT ViewCache, CacheStats;
FROM R2NumbIO IMPORT WriteCard, WriteAddr;
              
CONST   title = "Vol  Sec Count  Stamp    ";

VAR     i, v, s, n : CARDINAL;
        c, h, t : ADDRESS;
        rs : Status;

BEGIN   CacheStats(c,h);            
        WriteString("Reads: "); WriteAddr(c,10,1); 
        WriteString("    Hits: "); WriteAddr(h,10,1); 
        WriteLn;
        n := 0;
        WriteString(title);
        WriteString(title);
        WriteString(title);
        WriteLn;
        FOR i := 0 TO 61 DO
          rs := ViewCache(i,v,s,c,t);
          IF c > 0 THEN 
            WriteCard(v,2); WriteCard(s,6); WriteAddr(c,10,6); 
            WriteAddr(t,10,7); WriteString("    ");
            INC(n);
            IF (n MOD 3) = 0 THEN WriteLn END;
            END;
          END;
        IF (n MOD 3) <> 0 THEN WriteLn END;
END ShowCache.
