IMPLEMENTATION MODULE E2Displays;

FROM E2Terminal IMPORT WriteReverse, WriteCursor, EraseLine, MakeSpace;
FROM E2Functions IMPORT WriteLine, LineNumber;
FROM E2Pointer IMPORT Up, CanDo, EOF;
FROM E2Variables IMPORT row, text, lineptr, bottomline, paste1, literal; 

PROCEDURE Prompt(s : literal);

BEGIN   WriteReverse(23,1,s);
        prompt := TRUE;
END Prompt;

PROCEDURE ErasePrompt;

BEGIN   WriteCursor(23,1); EraseLine;
        WriteCursor(24,1); EraseLine;
        prompt := FALSE;
END ErasePrompt;

PROCEDURE CheckRange;
        
VAR     a, b : CARDINAL; 

BEGIN   a := LineNumber(text); b := LineNumber(paste1); 
        IF a <= b THEN
           IF (text^.up # NIL) AND (text^.up^.reverse) 
                THEN WriteLine(row-1,1,text^.up) END;
        END;
        IF a >= b THEN
           IF (NOT EOF()) AND (text^.down^.reverse)
                THEN WriteLine(row+1,1,text^.down) END;
        END;
        IF NOT text^.reverse THEN WriteLine(row,1,text) END;
END CheckRange;

PROCEDURE ReplaceTop(r : CARDINAL; p : lineptr;VAR yorn : BOOLEAN);

BEGIN   WHILE (r >=2 ) AND CanDo DO Up(p,r,TRUE) END;
        yorn := (row < 2) AND (p^.up # NIL); 
        IF yorn THEN 
          MakeSpace(1,row,TRUE);
          p := p^.up;
          WriteLine(1,1,p);
          INC(row);
          yorn := TRUE
        END
END ReplaceTop;

PROCEDURE ReplaceBottom(r : CARDINAL; p : lineptr; VAR yorn : BOOLEAN);

BEGIN   WHILE (r <= (bottomline-2)) AND CanDo DO Up(p,r,FALSE) END;
        yorn := (r > bottomline-2);
        IF yorn THEN 
          MakeSpace(row,bottomline,FALSE);
          IF p^.down # NIL THEN
                p := p^.down;
                WriteLine(bottomline,1,p);
          END
        END;
END ReplaceBottom;

END E2Displays.
