MODULE NewMail;        (* KGRW/GRG 87,88 *)

FROM R2SysCalls IMPORT Status, Translate, WriteString, Exit, WriteLn,
                       GetPID, SetUser;
FROM R2NewCalls IMPORT GetName;
FROM R2Strings IMPORT Insert, Copy, Length;
FROM R2Directories IMPORT SetWild, NextWild;
FROM R2NumbIO IMPORT WriteCard;

VAR
   i, pid : CARDINAL;
   rs : Status;
   line, user : ARRAY [0..79] OF CHAR;

BEGIN
   rs := GetPID(pid);
   IF rs <> Ok THEN Exit(rs) END;
   rs := GetName(pid,user);
   IF rs <> Ok THEN Exit(rs) END;
   IF Translate("$MAIL",line)<>Ok THEN 
      WriteString("NewMail -- $MAIL not found"); 
      WriteLn;
      Exit(Status(-1));
      END;
   Copy("$MAIL-N.*",line);
   Insert(user,line,Length(line)-2);
   rs := SetUser(pid,0);
   IF rs <> Ok THEN Exit(rs) END;
   IF SetWild(line)=Ok THEN
      i := 0;
      WHILE NextWild()=Ok DO INC(i) END;
      IF i>0 THEN
         WriteString("You have "); WriteCard(i,1);
         WriteString(" new mail message"); 
         IF i = 1 THEN WriteString(". ") ELSE WriteString("s.") END;
         WriteLn;
         END;
      END;
END NewMail.
