MODULE Math;   (* test out math fns *)

FROM RealIO IMPORT WriteFixed, ReadReal;
FROM R2SysCalls IMPORT WriteString, WriteLn;
FROM MathLib IMPORT Sin, Cos, Exp, Log, Arctan, Sqrt, Entier, Float;
FROM Random IMPORT Rand;

VAR     x : REAL;

BEGIN   LOOP WriteString("x: ");
             ReadReal(x);
             WriteString("Exp(x)    = "); WriteFixed(Exp(x),10,6); WriteLn;
             WriteString("Sin(x)    = "); WriteFixed(Sin(x),10,6); WriteLn;
             WriteString("Cos(x)    = "); WriteFixed(Cos(x),10,6); WriteLn;
             WriteString("Log(x)    = "); WriteFixed(Log(x),10,6); WriteLn;
             WriteString("Sqrt(x)   = "); WriteFixed(Sqrt(x),10,6); WriteLn;
             WriteString("Arctan(x) = "); WriteFixed(Arctan(x),10,6); WriteLn;
             WriteString("Entier(x) = "); WriteFixed(Float(Entier(x)),3,0);
                                          WriteLn;
             WriteString("Rand()    = "); WriteFixed(Rand(),10,6); WriteLn;
             END;
END Math.
