MODULE LookUp;
FROM DNS          IMPORT Resolve, RESULT, GetMessage;
FROM R2SysCalls   IMPORT WriteString,WriteLn,GetCommand, Write,ReadString;
FROM R2NewerCalls IMPORT IPAddr;
FROM R2NetSubs    IMPORT WriteIPAddr;
VAR
  ans,str:ARRAY[0..254] OF CHAR;  
  rs:RESULT;
  IPnum,ResolverIP:IPAddr;
  Resolver:ARRAY[0..100] OF CHAR;
BEGIN
  WriteString(' Default Server : ramsey.cs.laurentian.ca ');WriteLn;
  WriteString(' Address : 142.51.20.1 ');WriteLn;
  LOOP
    WriteLn;
    WriteString('>');
    ReadString(ans);WriteLn;
    rs:=Resolve(ans,IPnum,Resolver,ResolverIP);
    IF rs=NoError THEN
      WriteString(' Server  : ');      (*displays information*)
      WriteString(Resolver);WriteLn;
      WriteString(' Address : ');
      WriteIPAddr(ResolverIP,5);WriteLn; 
      WriteLn;
      WriteString(' Name    : ');
      WriteString(ans);WriteLn;
      WriteString(' Address : ');
      WriteIPAddr(IPnum,10);WriteLn;
      WriteLn;
    ELSIF rs=NoAnswer THEN
      WriteString('No Query type A exists in Answer section');
      WriteLn;
    ELSE
      GetMessage(str,rs);
      WriteLn;
      WriteString('*** ramsey.cs.laurentian.ca can not find ');
      WriteString(ans);WriteString(' : ');
      WriteString(str);WriteLn;
    END(*IF*);
   END(*LOOP*);
END LookUp.
