MODULE Touch;  (* Change a file's date to now *)

FROM Commands IMPORT GetArg;
FROM Errors IMPORT Error, SetName;
FROM R2SysCalls IMPORT Time, GetTime, Open, Close, Handle, Status;
FROM R2NewCalls IMPORT SetFileDate;

VAR     h : Handle;
        t : Time;
        fn, jn : ARRAY [0..79] OF CHAR;

PROCEDURE  Check( rs : Status; VAR op : ARRAY OF CHAR);

BEGIN   IF rs = Ok THEN RETURN END;
        Error(op,fn);
END Check;

BEGIN   SetName("Touch");
        fn[0] := 0C;
        Check(GetTime(t),"Error getting time");
        GetArg("File name",fn,jn,TRUE,FALSE);
        Check(Open(fn,TRUE,h),"Error opening");
        Check(SetFileDate(h,t),"Error touching");
        Check(Close(h,TRUE),"Error closing");
END Touch.
