IMPLEMENTATION MODULE Change;  (* Change mode editor for Linda *)

FROM R2SysCalls IMPORT Read, Write;

CONST   Max = 77;

VAR     Insert : BOOLEAN;

PROCEDURE  Display( VAR s : ARRAY OF CHAR; cp : CARDINAL);

VAR    k : CARDINAL;

BEGIN  k := 0;
       WHILE (s[cp] <> 0C) AND (cp < Max) DO 
         Write(s[cp]); INC(k); INC(cp); END;
       Write(' '); INC(k);
       FOR cp := 1 TO k DO Write(10C) END;
END Display;

PROCEDURE Edit( VAR s : ARRAY OF CHAR);

VAR    cp : CARDINAL;
       ch : CHAR;
       k : CARDINAL;

BEGIN   cp := 0;
        Display(s,0);
        LOOP  Read(ch,TRUE);
              IF (ch = 10C) AND (cp > 0) THEN
                  Write(10C); DEC(cp);
                ELSIF ((ch=11C) OR (ch = 12C)) AND (cp < Max)
                      AND (s[cp] <> 0C) THEN
                  Write(s[cp]); INC(cp);
                ELSIF ch = 1C THEN Insert := NOT Insert;
                ELSIF (ch = 177C) AND (cp > 0) THEN
                  DEC(cp);
                  k := cp;
                  WHILE s[k] <> 0C DO s[k] := s[k+1]; INC(k) END;
                  Write(10C);
                  Display(s,cp);
                ELSIF ch = 22C THEN 
                  Write(15C);
                  cp := 0; Display(s,0);
                ELSIF ch = 5C THEN
                  WHILE (cp < Max) AND (s[cp] <> 0C) DO
                    Write(s[cp]); INC(cp); END;
                ELSIF (ch =15C) OR (ch = 33C) OR (ch = 32C) THEN 
                  Write(12C); Write(15C); EXIT;
                ELSIF (ch <= '~') AND (ch >= ' ') AND (cp < Max) THEN
                  IF Insert THEN 
                    FOR k := HIGH(s)-1 TO cp+1 BY -1 DO s[k] := s[k-1] END;
                    s[HIGH(s)] := 0C
                    END;
                  s[cp] := ch; Write(ch); INC(cp);
                  IF Insert THEN Display(s,cp) END;
                END;
              END;
END Edit;

BEGIN  Insert := TRUE;
END Change.
