MODULE Check;

(* Compute a checksum on a file *)

FROM R2SysCalls IMPORT Open, Handle, ReadBlock, Close, WriteString, GetCommand,
                       WriteLn, Status, Exit;
FROM R2NumbIO IMPORT WriteCard;

VAR     h : Handle;
        b : RECORD 
              CASE BOOLEAN OF
                TRUE   : a : ARRAY [0..511] OF CHAR |
                FALSE  : w : ARRAY [0..255] OF CARDINAL;
                END;
              END;
        i, c, k : CARDINAL;
        f : ARRAY [0..79] OF CHAR;
        s : Status;

BEGIN   GetCommand(f);
        s := Open(f,FALSE,h);
        IF s <> Ok THEN Exit(s) END;
        c := 0;
        k := 0;
        LOOP s := ReadBlock(h,b.a);
             IF s = EndFile THEN EXIT END;
             IF s <> Ok THEN Exit(s) END;
             INC(k);
             FOR i := 0 TO 255 DO (*$T-*) INC(c,b.w[i]) (*$T=*) END;
             END;
        s := Close(h,TRUE);
        WriteString("Checksum = ");
        WriteCard(c,1);
        WriteString(" in ");
        WriteCard(k,1);
        WriteString(" blocks.");
        WriteLn;
END Check.
        
             
