MODULE Fell;  (* Drop a directory tree without questions *)

FROM R2SysCalls IMPORT WriteString, WriteLn, GetCommand, Open, Close,
                       FileMode, Delete, ModeBits,
                       GetMessage, Status, SetMode, Exit, Handle;
FROM R2Directories IMPORT NMode, FullName, SetWild, NextWild, NOwner;
FROM R2Strings IMPORT Concatenate, Copy;

PROCEDURE  Check( s : Status);    

VAR     m : ARRAY [0..39] OF CHAR;

BEGIN   IF s = Ok THEN RETURN END;
        GetMessage(s,m);
        WriteString("Fell -- ");
        WriteString(m);
        WriteLn;
        Exit(Status(-1));
END Check;

PROCEDURE  Drop( VAR tree : ARRAY OF CHAR);

VAR     h : Handle;
        rs : Status; 
        wc, df : ARRAY [0..79] OF CHAR;
        oo : CARDINAL;

BEGIN   Check(SetWild(tree));
        WHILE NextWild() = Ok DO
          IF DIR IN FileMode(NMode)
            THEN Copy(FullName,df);
                 oo := NOwner;
                 Concatenate(df,"-*",wc);
                 Drop(wc);  
                 Check(Open(df,TRUE,h));
                 Check(SetMode(h,FileMode(0FFH),oo));
                 Check(Close(h,TRUE));
                 Check(SetWild(tree));  (* Restart *)
            ELSE WriteString(FullName);
                 WriteLn;
                 Check(Delete(FullName));
            END;
          END;
END Drop;
                                    
VAR     com : ARRAY [0..79] OF CHAR;

BEGIN   GetCommand(com);
        Drop(com);
END Fell.
