MODULE Files;

FROM R2Directories IMPORT SetWild, NName, NextWild;
FROM R2SysCalls IMPORT WriteString, WriteLn, ReadString, GetCommand, 
                       Status, Exit, GetMessage;
FROM R2Strings IMPORT Length, Insert;

VAR     s : ARRAY [0..79] OF CHAR;
        c, n, k : CARDINAL;
        rs : Status;
       
PROCEDURE  Check( rs : Status);

BEGIN   IF rs = Ok THEN RETURN END;
        WriteString('Files -- ');
        GetMessage(rs,s);
        WriteString(s);
        WriteLn;
        Exit(Status(-1));
END Check;

BEGIN   GetCommand(s);
        Check(SetWild(s));
        s[0] := 0C;
        c := 0; n := 0;
        LOOP rs := NextWild();
             IF rs <> Ok THEN EXIT END;
             INC(n);
             k := Length(NName);
             IF c+k+2 > 80 THEN
               WriteString(s);
               WriteLn;
               s[0] := 0C;
               c := 0;
               END;
             IF c > 0 THEN 
               Insert("  ",s,c);
               INC(c,2);
               END;
             Insert(NName,s,c);
             INC(c,k);
             END;
        IF c > 0 THEN 
          WriteString(s);
          WriteLn;
          END;
        IF rs <> EndFile THEN Check(rs) END;
        IF n = 0 THEN 
          WriteString("Files -- No files found");
          WriteLn;
          END;
END Files.
