IMPLEMENTATION MODULE LockSync;  (* routines to sync programs with locks *)

FROM R2NewCalls IMPORT AttachLock, DetachLock, Lock, UnLock;
FROM R2SysCalls IMPORT Status, Sleep;

PROCEDURE  LockWait( VAR lck : ARRAY OF CHAR; secs : CARDINAL) : BOOLEAN;

(* Wait no more than secs for lck to be available *)

VAR     i : CARDINAL;

BEGIN   i := 0;      
        AttachLock(lck);
        LOOP IF Lock(lck) = Ok THEN EXIT END;
             IF i = secs THEN RETURN FALSE END;
             INC(i);
             IF Sleep(100) <> Ok THEN RETURN FALSE END;
             END;
        DetachLock;       
        RETURN TRUE;
END LockWait;

PROCEDURE  LockClear( VAR lck : ARRAY OF CHAR);

VAR     ig : Status;

BEGIN   ig := UnLock(lck);   (* ignore errors here *)
END LockClear;

END LockSync.
